
; CC5X Version 3.1I, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   4. Apr 2008  14:12  *************

	processor  16F88
	radix  DEC

INDF        EQU   0x00
PCL         EQU   0x02
FSR         EQU   0x04
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
PCLATH      EQU   0x0A
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
IRP         EQU   7
GIE         EQU   7
RCSTA       EQU   0x18
TXREG       EQU   0x19
RCREG       EQU   0x1A
TXSTA       EQU   0x98
SPBRG       EQU   0x99
ANSEL       EQU   0x9B
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EEDATH      EQU   0x10E
EEADRH      EQU   0x10F
PEIE        EQU   6
TXIF        EQU   4
RCIF        EQU   5
CREN        EQU   4
SPEN        EQU   7
TXIE        EQU   4
RCIE        EQU   5
BRGH        EQU   2
SYNC        EQU   4
TXEN        EQU   5
RD          EQU   0
EEPGD       EQU   7
x           EQU   0x30
x_2         EQU   0x7F
y           EQU   0x7F
z           EQU   0x7F
x_3         EQU   0x7F
y_2         EQU   0x7F
want_ints   EQU   0
want_ints_2 EQU   0
nate        EQU   0x3B
counter     EQU   0x7F
x_4         EQU   0x3B
nate_2      EQU   0x2B
my_byte     EQU   0x2C
i           EQU   0x2E
k           EQU   0x2F
m           EQU   0x30
temp        EQU   0x31
high_byte   EQU   0x32
low_byte    EQU   0x33
C1cnt       EQU   0x3B
C2tmp       EQU   0x3C
C3cnt       EQU   0x3B
C4tmp       EQU   0x3C
C5cnt       EQU   0x3B
C6tmp       EQU   0x3C
C7rem       EQU   0x3E
response    EQU   0x21
red         EQU   0x22
green       EQU   0x24
blue        EQU   0x26
clear       EQU   0x28
i_2         EQU   0x2A
register_name EQU   0x2B
in_byte     EQU   0x2C
register_name_2 EQU   0x2B
register_value EQU   0x2C
device_address EQU   0x2D
j           EQU   0x2D
in_byte_2   EQU   0x2E
out_byte    EQU   0x2E
i_3         EQU   0x2F
ci          EQU   0x3B

	GOTO main

  ; FILE C:\Global\Code\16F88\ColorSensor-Testing\ADJD-S371-v11.c
			;/*
			;    3-17-08
			;    Nathan Seidle
			;    nathan@sparkfun.com
			;    Copyright Spark Fun Electronics 2008
			;    
			;    Written for a PIC 16F88 running SparkFun bootloader at internal 8MHz.
			;    Compiled with CC5x compiler.
			;
			;    Basic software I2C interactions with the ADJD-S371-Q999 color
			;    sensor. Sensor works great but requires calibration. This firwmare
			;    is only meant to demonstrate simple command interface.
			;    
			;    The software I2C routines are heavily tested and seem to work well
			;    with many I2C devices.
			;*/
			;#define Clock_8MHz
			;#define Baud_9600
			;
			;#include "c:\Global\Code\C\16F88.h"  // device dependent interrupt definitions
			;
			;#pragma origin 4
	ORG 0x0004

  ; FILE c:\Global\Code\Pics\Code\Delay.c
			;/*
			;    7/23/02
			;    Nathan Seidle
			;    nathan.seidle@colorado.edu
			;    
			;    Delays for... Well, everything.
			;    
			;    11-11 Updated the delays - now they actually delay what they say they should.
			;    
			;    10-11-03 Updated delays. New CC5X compiler is muy optimized.
			;
			;*/
			;
			;//Really short delay
			;void delay_us(uns16 x)
			;{
_const1
	MOVWF ci
	MOVLW .0
	BSF   0x03,RP1
	MOVWF EEADRH
	BCF   0x03,RP1
	RRF   ci,W
	ANDLW .127
	ADDLW .35
	BSF   0x03,RP1
	MOVWF EEADR
	BTFSC 0x03,Carry
	INCF  EEADRH,1
	BSF   0x03,RP0
	BSF   0x18C,EEPGD
	BSF   0x18C,RD
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC ci,0
	GOTO  m001
	BSF   0x03,RP1
	MOVF  EEDATA,W
	ANDLW .127
	BCF   0x03,RP1
	RETURN
m001	BSF   0x03,RP1
	RLF   EEDATA,W
	RLF   EEDATH,W
	BCF   0x03,RP1
	RETURN
	DW    0x68A
	DW    0x208A
	DW    0x2544
	DW    0x1044
	DW    0x32D4
	DW    0x3A73
	DW    0x3769
	DW    0x567
	DW    0xD
	DW    0x1EE9
	DW    0x3225
	DW    0x20
	DW    0x1452
	DW    0x3425
	DW    0x1029
	DW    0x2380
	DW    0x12A8
	DW    0x14E8
	DW    0x20
	DW    0x1442
	DW    0x3425
	DW    0x1029
	DW    0x2180
	DW    0x12A8
	DW    0x14E8
	DW    0x0
delay_us
			;
			;#ifdef Clock_4MHz
			;    //Calling with 10us returns 69us
			;    for ( ; x > 0 ; x--);
			;#endif
			;
			;#ifdef Clock_8MHz
			;    //Calling with 1us returns 11us
			;    //Calling with 10us returns 56us
			;    //for ( ; x > 0 ; x--);
			;    
			;    //Calling with 1us returns 7.5us
			;    //Calling with 10us returns 48
			;    //Calling with 1000us returns 4.5ms
			;    while(--x); 
m002	DECF  x,1
	INCF  x,W
	BTFSC 0x03,Zero_
	DECF  x+1,1
	MOVF  x,W
	IORWF x+1,W
	BTFSS 0x03,Zero_
	GOTO  m002
			;
			;    //while(x--); 
			;#endif
			;
			;#ifdef Clock_9216MHz
			;    //Copied from 8MHz - not tested
			;    while(--x); 
			;#endif
			;
			;#ifdef Clock_10MHz
			;    //delay_us(1) = 6.4us
			;    //delay_us(10) = 16.8us
			;    //delay_us(100) = 110.4us
			;    while(x > 4) x -= 5;
			;#endif
			;
			;#ifdef Clock_20MHz
			;    //Calling with 10us returns 13 us
			;    //Calling with 1us returns 1.8us
			;    while(--x) nop(); 
			;#endif
			;
			;}
	RETURN
			;
			;//General short delay
			;void delay_ms(uns16 x)
			;{
delay_ms
			;
			;#ifdef Clock_4MHz
			;    //Clocks out at 1002us per 1ms
			;    int y;
			;    for ( ; x > 0 ; x--)
			;        for ( y = 0 ; y < 108 ; y++);
			;#endif
			;
			;#ifdef Clock_8MHz
			;    //Clocks out at 1006us per 1ms
			;    uns8 y, z;
			;    for ( ; x > 0 ; x--)
m003	MOVF  x_2,W
	IORWF x_2+1,W
	BTFSC 0x03,Zero_
	GOTO  m008
			;        for ( y = 0 ; y < 4 ; y++)
	CLRF  y
m004	MOVLW .4
	SUBWF y,W
	BTFSC 0x03,Carry
	GOTO  m007
			;            for ( z = 0 ; z < 69 ; z++);
	CLRF  z
m005	MOVLW .69
	SUBWF z,W
	BTFSC 0x03,Carry
	GOTO  m006
	INCF  z,1
	GOTO  m005
m006	INCF  y,1
	GOTO  m004
m007	DECF  x_2,1
	INCF  x_2,W
	BTFSC 0x03,Zero_
	DECF  x_2+1,1
	GOTO  m003
			;#endif
			;
			;#ifdef Clock_9216MHz
			;    //Copied from 8MHz - not tested
			;    uns8 y, z;
			;    for ( ; x > 0 ; x--)
			;        for ( y = 0 ; y < 4 ; y++)
			;            for ( z = 0 ; z < 69 ; z++);
			;#endif
			;
			;#ifdef Clock_10MHz
			;    //delay_ms(1) = 1.006ms
			;    //delay_ms(10) = 10.02ms
			;    //delay_ms(100) = 100.16ms
			;
			;    uns8 y, z;
			;    for ( ; x > 0 ; x--)
			;        for ( y = 0 ; y < 4 ; y++)
			;            for ( z = 0 ; z < 87 ; z++);
			;#endif
			;
			;#ifdef Clock_20MHz
			;
			;    uns8 y, z;
			;    //Clocks out to 1.00ms per 1ms
			;    //9.99 ms per 10ms
			;    for ( ; x > 0 ; x--)
			;        for ( y = 0 ; y < 4 ; y++)
			;            for ( z = 0 ; z < 176 ; z++);
			;#endif
			;
			;}
m008	RETURN
			;
			;//Delays in 31.25kHz Low Power mode using the internal 31.25kHz oscillator
			;void delay_s_lp(uns16 x)
			;{
delay_s_lp
			;
			;    uns16 y;
			;    //Clocks out to 1.001s per 1s
			;    for ( ; x > 0 ; x--)
m009	MOVF  x_3,W
	IORWF x_3+1,W
	BTFSC 0x03,Zero_
	GOTO  m013
			;        for ( y = 0 ; y < 775 ; y++);
	CLRF  y_2
	CLRF  y_2+1
m010	MOVLW .3
	SUBWF y_2+1,W
	BTFSS 0x03,Carry
	GOTO  m011
	BTFSS 0x03,Zero_
	GOTO  m012
	MOVLW .7
	SUBWF y_2,W
	BTFSC 0x03,Carry
	GOTO  m012
m011	INCF  y_2,1
	BTFSC 0x03,Zero_
	INCF  y_2+1,1
	GOTO  m010
m012	DECF  x_3,1
	INCF  x_3,W
	BTFSC 0x03,Zero_
	DECF  x_3+1,1
	GOTO  m009

  ; FILE C:\Global\Code\16F88\ColorSensor-Testing\ADJD-S371-v11.c
			;
			;#include "c:\Global\Code\Pics\Code\Delay.c"   //Standard delays
m013	RETURN

  ; FILE c:\Global\Code\Pics\Code\stdio.c
			;/*
			;    5/21/02
			;    Nathan Seidle
			;    nathan.seidle@colorado.edu
			;    
			;    Serial Out Started on 5-21
			;    rs_out Perfected on 5-24
			;    
			;    1Wire Serial Comm works with 4MHz Xtal
			;    Connect Serial_Out to Pin2 on DB9 Serial Connector
			;    Connect Pin5 on DB9 Connector to Signal Ground
			;    9600 Baud 8-N-1
			;    
			;    5-21 My first real C and Pic program.
			;    5-24 Attempting 20MHz implementation
			;    5-25 20MHz works
			;    5-25 Serial In works at 4MHz
			;    5-25 Passing Strings 9:20
			;    5-25 Option Selection 9:45
			;
			;    6-9  'Stdio.c' created. Printf working with %d and %h
			;    7-20 Added a longer delay after rs_out
			;         Trying to get 20MHz on the 16F873 - I think the XTal is bad.
			;         20MHz also needs 5V Vdd. Something I dont have.
			;    2-9-03 Overhauled the 4MHz timing. Serial out works very well now.
			;    
			;    6-16-03 Discovered how to pass string in cc5x
			;        void test(const char *str);
			;        test("zbcdefghij"); TXREG = str[1];
			;        
			;        Moved to hardware UART. Old STDIO will be in goodworks.
			;        
			;        Works great! Even got the special print characters (\n, \r, \0) to work.
			;    
			;    4-25-04 Added new %d routine to print 16 bit signed decimal numbers without leading 0s.
			;        
			;
			;*/
			;
			;//Setup the hardware UART TX module
			;void enable_uart_TX(bit want_ints)
			;{
enable_uart_TX
			;    BRGH = 0; //Normal speed UART
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x98,BRGH
			;
			;    SYNC = 0;
	BCF   0x98,SYNC
			;    SPEN = 1;
	BCF   0x03,RP0
	BSF   0x18,SPEN
			;
			;#ifdef Clock_4MHz
			;    #ifdef Baud_9600
			;    SPBRG = 6; //4MHz for 9600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Clock_8MHz
			;    #ifdef Baud_4800
			;    SPBRG = 25; //8MHz for 4800 Baud
			;    #endif
			;    #ifdef Baud_9600
			;    SPBRG = 12; //8MHz for 9600 Baud
	MOVLW .12
	BSF   0x03,RP0
	MOVWF SPBRG
			;    #endif
			;    #ifdef Baud_57600
			;    BRGH = 1; //High speed UART
			;    SPBRG = 7; //8MHz for 57600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Crazy_Osc
			;    #ifdef Baud_9600
			;    SPBRG = 32; //20MHz for 9600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Clock_20MHz
			;    #ifdef Baud_9600
			;    SPBRG = 31; //20MHz for 9600 Baud
			;    #endif
			;
			;    #ifdef Baud_4800
			;    SPBRG = 64; //20MHz for 4800 Baud
			;    #endif
			;#endif
			;
			;    if(want_ints) //Check if we want to turn on interrupts
	BTFSS 0x7F,want_ints
	GOTO  m014
			;    {
			;        TXIE = 1;
	BSF   0x8C,TXIE
			;        PEIE = 1;
	BSF   0x0B,PEIE
			;        GIE = 1;
	BSF   0x0B,GIE
			;    }
			;
			;    TXEN = 1; //Enable transmission
m014	BSF   0x98,TXEN
			;}    
	RETURN
			;
			;//Setup the hardware UART RX module
			;void enable_uart_RX(bit want_ints)
			;{
enable_uart_RX
			;
			;    BRGH = 0; //Normal speed UART
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x98,BRGH
			;
			;    SYNC = 0;
	BCF   0x98,SYNC
			;    SPEN = 1;
	BCF   0x03,RP0
	BSF   0x18,SPEN
			;
			;#ifdef Clock_4MHz
			;    #ifdef Baud_9600
			;    SPBRG = 6; //4MHz for 9600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Clock_8MHz
			;    #ifdef Baud_4800
			;    SPBRG = 25; //8MHz for 4800 Baud
			;    #endif
			;    #ifdef Baud_9600
			;    SPBRG = 12; //8MHz for 9600 Baud
	MOVLW .12
	BSF   0x03,RP0
	MOVWF SPBRG
			;    #endif
			;    #ifdef Baud_57600
			;    BRGH = 1; //High speed UART
			;    SPBRG = 8; //8MHz for 57600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Crazy_Osc
			;    #ifdef Baud_9600
			;    SPBRG = 32; //20MHz for 9600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Clock_20MHz
			;    #ifdef Baud_9600
			;    SPBRG = 31; //20MHz for 9600 Baud
			;    #endif
			;
			;    #ifdef Baud_4800
			;    SPBRG = 64; //20MHz for 4800 Baud
			;    #endif
			;#endif
			;
			;    CREN = 1;
	BCF   0x03,RP0
	BSF   0x18,CREN
			;
			;    //WREN = 1;
			;
			;    if(want_ints) //Check if we want to turn on interrupts
	BTFSS 0x7F,want_ints_2
	GOTO  m015
			;    {
			;        RCIE = 1;
	BSF   0x03,RP0
	BSF   0x8C,RCIE
			;        PEIE = 1;
	BSF   0x0B,PEIE
			;        GIE = 1;
	BSF   0x0B,GIE
			;    }
			;
			;}    
m015	BSF   0x03,RP0
	RETURN
			;
			;//Sends nate to the Transmit Register
			;void putc(uns8 nate)
			;{
putc
	MOVWF nate
			;    while(TXIF == 0);
m016	BTFSS 0x0C,TXIF
	GOTO  m016
			;    TXREG = nate;
	MOVF  nate,W
	MOVWF TXREG
			;}
	RETURN
			;
			;uns8 getc(void)
			;{
getc
			;    while(RCIF == 0);
	BCF   0x03,RP0
	BCF   0x03,RP1
m017	BTFSS 0x0C,RCIF
	GOTO  m017
			;    return (RCREG);
	MOVF  RCREG,W
	RETURN
			;}    
			;
			;uns8 scanc(void)
			;{
scanc
			;    uns16 counter = 0;
	CLRF  counter
	CLRF  counter+1
			;    
			;    //CREN = 0;
			;    //CREN = 1;
			;    
			;    RCIF = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x0C,RCIF
			;    while(RCIF == 0)
m018	BTFSC 0x0C,RCIF
	GOTO  m019
			;    {
			;        counter++;
	INCF  counter,1
	BTFSC 0x03,Zero_
	INCF  counter+1,1
			;        if(counter == 1000) return 0;
	MOVF  counter,W
	XORLW .232
	BTFSS 0x03,Zero_
	GOTO  m018
	MOVF  counter+1,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m018
	RETLW .0
			;    }
			;    
			;    return (RCREG);
m019	MOVF  RCREG,W
	RETURN
			;}    
			;
			;//Returns ASCII Decimal and Hex values
			;uns8 bin2Hex(char x)
			;{
bin2Hex
	MOVWF x_4
			;   skip(x);
	CLRF  PCLATH
	MOVF  x_4,W
	ADDWF PCL,1
			;   #pragma return[16] = "0123456789ABCDEF"
	RETLW .48
	RETLW .49
	RETLW .50
	RETLW .51
	RETLW .52
	RETLW .53
	RETLW .54
	RETLW .55
	RETLW .56
	RETLW .57
	RETLW .65
	RETLW .66
	RETLW .67
	RETLW .68
	RETLW .69
	RETLW .70
			;}
			;
			;//Prints a string including variables
			;void printf(const char *nate, int16 my_byte)
			;{
printf
			;  
			;    uns8 i, k, m, temp;
			;    uns8 high_byte = 0, low_byte = 0;
	CLRF  high_byte
	CLRF  low_byte
			;    uns8 y, z;
			;    
			;    uns8 decimal_output[5];
			;    
			;    for(i = 0 ; ; i++)
	CLRF  i
			;    {
			;        //delay_ms(3);
			;        
			;        k = nate[i];
m020	MOVF  i,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;
			;        if (k == '\0') 
	MOVF  k,1
	BTFSC 0x03,Zero_
			;            break;
	GOTO  m046
			;
			;        else if (k == '%') //Print var
	XORLW .37
	BTFSS 0x03,Zero_
	GOTO  m044
			;        {
			;            i++;
	INCF  i,1
			;            k = nate[i];
	MOVF  i,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;
			;            if (k == '\0') 
	MOVF  k,1
	BTFSC 0x03,Zero_
			;                break;
	GOTO  m046
			;            else if (k == '\\') //Print special characters
	XORLW .92
	BTFSS 0x03,Zero_
	GOTO  m021
			;            {
			;                i++;
	INCF  i,1
			;                k = nate[i];
	MOVF  i,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;                
			;                putc(k);
	CALL  putc
			;                
			;
			;            } //End Special Characters
			;            else if (k == 'b') //Print Binary
	GOTO  m045
m021	MOVF  k,W
	XORLW .98
	BTFSS 0x03,Zero_
	GOTO  m026
			;            {
			;                for( m = 0 ; m < 8 ; m++ )
	CLRF  m
m022	MOVLW .8
	SUBWF m,W
	BTFSC 0x03,Carry
	GOTO  m045
			;                {
			;                    if (my_byte.7 == 1) putc('1');
	BTFSS my_byte,7
	GOTO  m023
	MOVLW .49
	CALL  putc
			;                    if (my_byte.7 == 0) putc('0');
m023	BTFSC my_byte,7
	GOTO  m024
	MOVLW .48
	CALL  putc
			;                    if (m == 3) putc(' ');
m024	MOVF  m,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m025
	MOVLW .32
	CALL  putc
			;                    
			;                    my_byte = my_byte << 1;
m025	BCF   0x03,Carry
	RLF   my_byte,1
	RLF   my_byte+1,1
			;                }
	INCF  m,1
	GOTO  m022
			;            } //End Binary               
			;            else if (k == 'd') //Print Decimal
m026	MOVF  k,W
	XORLW .100
	BTFSS 0x03,Zero_
	GOTO  m040
			;            {
			;                //Print negative sign and take 2's compliment
			;                
			;                if(my_byte < 0)
	BTFSS my_byte+1,7
	GOTO  m029
			;                {
			;                    putc('-');
	MOVLW .45
	CALL  putc
			;                    my_byte *= -1;
	MOVF  my_byte,W
	MOVWF C2tmp
	MOVF  my_byte+1,W
	MOVWF C2tmp+1
	MOVLW .16
	MOVWF C1cnt
m027	BCF   0x03,Carry
	RLF   my_byte,1
	RLF   my_byte+1,1
	RLF   C2tmp,1
	RLF   C2tmp+1,1
	BTFSS 0x03,Carry
	GOTO  m028
	DECF  my_byte+1,1
	DECF  my_byte,1
	INCFSZ my_byte,W
	INCF  my_byte+1,1
m028	DECFSZ C1cnt,1
	GOTO  m027
			;                }
			;                
			;                
			;                if (my_byte == 0)
m029	MOVF  my_byte,W
	IORWF my_byte+1,W
	BTFSS 0x03,Zero_
	GOTO  m030
			;                    putc('0');
	MOVLW .48
	CALL  putc
			;                else
	GOTO  m045
			;                {
			;                    //Divide number by a series of 10s
			;                    for(m = 4 ; my_byte > 0 ; m--)
m030	MOVLW .4
	MOVWF m
m031	BTFSC my_byte+1,7
	GOTO  m038
	MOVF  my_byte,W
	IORWF my_byte+1,W
	BTFSC 0x03,Zero_
	GOTO  m038
			;                    {
			;                        temp = my_byte % (uns16)10;
	MOVF  my_byte,W
	MOVWF C4tmp
	MOVF  my_byte+1,W
	MOVWF C4tmp+1
	CLRF  temp
	MOVLW .16
	MOVWF C3cnt
m032	RLF   C4tmp,1
	RLF   C4tmp+1,1
	RLF   temp,1
	BTFSC 0x03,Carry
	GOTO  m033
	MOVLW .10
	SUBWF temp,W
	BTFSS 0x03,Carry
	GOTO  m034
m033	MOVLW .10
	SUBWF temp,1
m034	DECFSZ C3cnt,1
	GOTO  m032
			;                        decimal_output[m] = temp;
	MOVLW .54
	ADDWF m,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  temp,W
	MOVWF INDF
			;                        my_byte = my_byte / (uns16)10;               
	MOVF  my_byte,W
	MOVWF C6tmp
	MOVF  my_byte+1,W
	MOVWF C6tmp+1
	CLRF  C7rem
	MOVLW .16
	MOVWF C5cnt
m035	RLF   C6tmp,1
	RLF   C6tmp+1,1
	RLF   C7rem,1
	BTFSC 0x03,Carry
	GOTO  m036
	MOVLW .10
	SUBWF C7rem,W
	BTFSS 0x03,Carry
	GOTO  m037
m036	MOVLW .10
	SUBWF C7rem,1
	BSF   0x03,Carry
m037	RLF   my_byte,1
	RLF   my_byte+1,1
	DECFSZ C5cnt,1
	GOTO  m035
			;                    }
	DECF  m,1
	GOTO  m031
			;                
			;                    for(m++ ; m < 5 ; m++)
m038	INCF  m,1
m039	MOVLW .5
	SUBWF m,W
	BTFSC 0x03,Carry
	GOTO  m045
			;                        putc(bin2Hex(decimal_output[m]));
	MOVLW .54
	ADDWF m,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  INDF,W
	CALL  bin2Hex
	CALL  putc
	INCF  m,1
	GOTO  m039
			;                }
			;    
			;            } //End Decimal
			;            else if (k == 'h') //Print Hex
m040	MOVF  k,W
	XORLW .104
	BTFSS 0x03,Zero_
	GOTO  m042
			;            {
			;                //New trick 3-15-04
			;                putc('0');
	MOVLW .48
	CALL  putc
			;                putc('x');
	MOVLW .120
	CALL  putc
			;                
			;                if(my_byte > 0x00FF)
	BTFSC my_byte+1,7
	GOTO  m041
	MOVF  my_byte+1,1
	BTFSC 0x03,Zero_
	GOTO  m041
			;                {
			;                    putc(bin2Hex(my_byte.high8 >> 4));
	SWAPF my_byte+1,W
	ANDLW .15
	CALL  bin2Hex
	CALL  putc
			;                    putc(bin2Hex(my_byte.high8 & 0b.0000.1111));
	MOVLW .15
	ANDWF my_byte+1,W
	CALL  bin2Hex
	CALL  putc
			;                }
			;
			;                putc(bin2Hex(my_byte.low8 >> 4));
m041	SWAPF my_byte,W
	ANDLW .15
	CALL  bin2Hex
	CALL  putc
			;                putc(bin2Hex(my_byte.low8 & 0b.0000.1111));
	MOVLW .15
	ANDWF my_byte,W
	CALL  bin2Hex
	CALL  putc
			;
			;                /*high_byte.3 = my_byte.7;
			;                high_byte.2 = my_byte.6;
			;                high_byte.1 = my_byte.5;
			;                high_byte.0 = my_byte.4;
			;            
			;                low_byte.3 = my_byte.3;
			;                low_byte.2 = my_byte.2;
			;                low_byte.1 = my_byte.1;
			;                low_byte.0 = my_byte.0;
			;        
			;                putc('0');
			;                putc('x');
			;            
			;                putc(bin2Hex(high_byte));
			;                putc(bin2Hex(low_byte));*/
			;            } //End Hex
			;            else if (k == 'f') //Print Float
	GOTO  m045
m042	MOVF  k,W
	XORLW .102
	BTFSS 0x03,Zero_
	GOTO  m043
			;            {
			;                putc('!');
	MOVLW .33
	CALL  putc
			;            } //End Float
			;            else if (k == 'u') //Print Direct Character
	GOTO  m045
m043	MOVF  k,W
	XORLW .117
	BTFSS 0x03,Zero_
	GOTO  m045
			;            {
			;                //All ascii characters below 20 are special and screwy characters
			;                //if(my_byte > 20) 
			;                    putc(my_byte);
	MOVF  my_byte,W
	CALL  putc
			;            } //End Direct
			;                        
			;        } //End Special Chars           
			;
			;        else
	GOTO  m045
			;            putc(k);
m044	MOVF  k,W
	CALL  putc
			;    }    
m045	INCF  i,1
	GOTO  m020
			;}
m046	RETURN

  ; FILE C:\Global\Code\16F88\ColorSensor-Testing\ADJD-S371-v11.c
			;#include "c:\Global\Code\Pics\Code\stdio.c"   //Software based Basic Serial IO
			;
			;#define STATUS_LED PORTB.3
			;
			;void boot_up(void);
			;
			;#define WRITE_sda() TRISB = TRISB & 0b.1011.1111 //SDA must be output when writing
			;#define READ_sda()  TRISB = TRISB | 0b.0100.0000 //SDA must be input when reading - don't forget the resistor on SDA!!
			;
			;#define SCL PORTB.7
			;#define SDA PORTB.6
			;
			;#define I2C_DELAY   1
			;
			;#define ACK     1
			;#define NO_ACK  0
			;
			;#define DEVICE_WRITE    0xE8 //Default ADJD-S371 I2C address - write
			;#define DEVICE_READ     0xE9 //Default ADJD-S371 I2C address - read
			;
			;#define CAP_RED         0x06
			;#define CAP_GREEN       0x07
			;#define CAP_BLUE        0x08
			;#define CAP_CLEAR       0x09
			;
			;#define INT_RED_LO      0x0A
			;#define INT_RED_HI      0x0B
			;#define INT_GREEN_LO    0x0C
			;#define INT_GREEN_HI    0x0D
			;#define INT_BLUE_LO     0x0E
			;#define INT_BLUE_HI     0x0F
			;#define INT_CLEAR_LO    0x10
			;#define INT_CLEAR_HI    0x11
			;
			;#define DATA_RED_LO     0x40
			;#define DATA_RED_HI     0x41
			;#define DATA_GREEN_LO   0x42
			;#define DATA_GREEN_HI   0x43
			;#define DATA_BLUE_LO    0x44
			;#define DATA_BLUE_HI    0x45
			;#define DATA_CLEAR_LO   0x46
			;#define DATA_CLEAR_HI   0x47
			;
			;void adjd_s371_read(void);
			;void adjd_init(void);
			;
			;void i2c_ack_polling(uns8 device_address);
			;void i2c_start(void);
			;void i2c_stop(void);
			;uns8 i2c_read_byte(void);
			;bit i2c_send_byte(uns8 out_byte);
			;uns8 read_register(uns8 register_name);
			;void write_register(uns8 register_name, uns8 register_value);
			;
			;void main(void)
			;{
main
			;    uns8 choice;
			;    
			;    boot_up();
	BSF   0x03,RP0
	BCF   0x03,RP1
	CALL  boot_up
			;        
			;    printf("\n\r\n\ADJD Testing\n\r", 0);
	CLRF  nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;
			;    adjd_init();
	CALL  adjd_init
			;    
			;    while(1)
			;    {
			;        adjd_s371_read();
m047	CALL  adjd_s371_read
			;        //delay_ms(10);
			;    }
	GOTO  m047
			;    
			;    while(1);
m048	GOTO  m048
			;
			;}//End Main
			;
			;void boot_up(void)
			;{
boot_up
			;    //OSCCON = 0b.0111.0000; //Setup internal oscillator for 8MHz
			;    //while(OSCCON.2 == 0); //Wait for frequency to stabilize
			;
			;    //Setup Ports
			;    ANSEL = 0b.0000.0000; //Turn off A/D
	CLRF  ANSEL
			;
			;    PORTA = 0b.0000.0000;
	BCF   0x03,RP0
	CLRF  PORTA
			;    TRISA = 0b.0000.0000;
	BSF   0x03,RP0
	CLRF  TRISA
			;
			;    PORTB = 0b.0001.0000;
	MOVLW .16
	BCF   0x03,RP0
	MOVWF PORTB
			;    TRISB = 0b.0000.0100;   //0 = Output, 1 = Input RX on RB2
	MOVLW .4
	BSF   0x03,RP0
	MOVWF TRISB
			;
			;    //Setup the hardware UART module
			;    //=============================================================
			;    SPBRG = 51; //8MHz for 9600 inital communication baud rate
	MOVLW .51
	MOVWF SPBRG
			;    //SPBRG = 59; //9.216MHz for 9600 inital communication baud rate
			;    //SPBRG = 4; //9.216MHz for 115200 inital communication baud rate
			;    //SPBRG = 129; //20MHz for 9600 inital communication baud rate
			;
			;    TXSTA = 0b.0010.0100; //8-bit asych mode, high speed uart enabled
	MOVLW .36
	MOVWF TXSTA
			;    RCSTA = 0b.1001.0000; //Serial port enable, 8-bit asych continous receive mode
	MOVLW .144
	BCF   0x03,RP0
	MOVWF RCSTA
			;    //=============================================================
			;
			;}
	RETURN
			;
			;void adjd_init(void)
			;{
adjd_init
			;    write_register(CAP_RED, 0x05);
	MOVLW .6
	MOVWF register_name_2
	MOVLW .5
	CALL  write_register
			;    write_register(CAP_GREEN, 0x05);
	MOVLW .7
	MOVWF register_name_2
	MOVLW .5
	CALL  write_register
			;    write_register(CAP_BLUE, 0x05);
	MOVLW .8
	MOVWF register_name_2
	MOVLW .5
	CALL  write_register
			;    write_register(CAP_CLEAR, 0x05);
	MOVLW .9
	MOVWF register_name_2
	MOVLW .5
	CALL  write_register
			;    
			;    write_register(INT_RED_LO, 0xC4);
	MOVLW .10
	MOVWF register_name_2
	MOVLW .196
	CALL  write_register
			;    write_register(INT_RED_HI, 0x09);
	MOVLW .11
	MOVWF register_name_2
	MOVLW .9
	CALL  write_register
			;    write_register(INT_GREEN_LO, 0xC4);
	MOVLW .12
	MOVWF register_name_2
	MOVLW .196
	CALL  write_register
			;    write_register(INT_GREEN_HI, 0x09);
	MOVLW .13
	MOVWF register_name_2
	MOVLW .9
	CALL  write_register
			;    write_register(INT_BLUE_LO, 0xC4);
	MOVLW .14
	MOVWF register_name_2
	MOVLW .196
	CALL  write_register
			;    write_register(INT_BLUE_HI, 0x09);
	MOVLW .15
	MOVWF register_name_2
	MOVLW .9
	CALL  write_register
			;    write_register(INT_CLEAR_LO, 0xC4);
	MOVLW .16
	MOVWF register_name_2
	MOVLW .196
	CALL  write_register
			;    write_register(INT_CLEAR_HI, 0x09);
	MOVLW .17
	MOVWF register_name_2
	MOVLW .9
	GOTO  write_register
			;}
			;
			;//Init the sensor and read out the humidity and temperature data
			;void adjd_s371_read(void)
			;{
adjd_s371_read
			;    uns8 response;
			;    uns16 red, green, blue, clear;
			;
			;    //Check ability to read CAP_RED (should be 15)
			;    //response = read_register(CAP_RED);
			;    //printf("CAP_RED:%d ", response);
			;
			;    write_register(0x00, 0b.0000.0001); //Get sensor reading
	CLRF  register_name_2
	MOVLW .1
	CALL  write_register
			;    
			;    uns8 i = 0;
	CLRF  i_2
			;    while(1)
			;    {
			;        response = read_register(0x00);
m049	MOVLW .0
	CALL  read_register
	MOVWF response
			;        if (response == 0) break;
	MOVF  response,1
	BTFSC 0x03,Zero_
	GOTO  m050
			;        i++;
	INCF  i_2,1
			;    }
	GOTO  m049
			;    printf("i=%d ", i);
m050	MOVLW .18
	MOVWF nate_2
	MOVF  i_2,W
	MOVWF my_byte
	CLRF  my_byte+1
	CALL  printf
			;        
			;    //Red
			;    red.low8 = read_register(DATA_RED_LO);
	MOVLW .64
	CALL  read_register
	MOVWF red
			;    red.high8 = read_register(DATA_RED_HI);
	MOVLW .65
	CALL  read_register
	MOVWF red+1
			;
			;    //Green
			;    green.low8 = read_register(DATA_GREEN_LO);
	MOVLW .66
	CALL  read_register
	MOVWF green
			;    green.high8 = read_register(DATA_GREEN_HI);
	MOVLW .67
	CALL  read_register
	MOVWF green+1
			;
			;    //Blue
			;    blue.low8 = read_register(DATA_BLUE_LO);
	MOVLW .68
	CALL  read_register
	MOVWF blue
			;    blue.high8 = read_register(DATA_BLUE_HI);
	MOVLW .69
	CALL  read_register
	MOVWF blue+1
			;
			;    //Clear
			;    clear.low8 = read_register(DATA_CLEAR_LO);
	MOVLW .70
	CALL  read_register
	MOVWF clear
			;    clear.high8 = read_register(DATA_CLEAR_HI);
	MOVLW .71
	CALL  read_register
	MOVWF clear+1
			;    
			;
			;    printf("R(%h) ", red);
	MOVLW .24
	MOVWF nate_2
	MOVF  red,W
	MOVWF my_byte
	MOVF  red+1,W
	MOVWF my_byte+1
	CALL  printf
			;    printf("G(%h) ", green);
	MOVLW .31
	MOVWF nate_2
	MOVF  green,W
	MOVWF my_byte
	MOVF  green+1,W
	MOVWF my_byte+1
	CALL  printf
			;    printf("B(%h) ", blue);
	MOVLW .38
	MOVWF nate_2
	MOVF  blue,W
	MOVWF my_byte
	MOVF  blue+1,W
	MOVWF my_byte+1
	CALL  printf
			;    printf("C(%h)", clear);
	MOVLW .45
	MOVWF nate_2
	MOVF  clear,W
	MOVWF my_byte
	MOVF  clear+1,W
	MOVWF my_byte+1
	CALL  printf
			;    
			;    printf("\r", 0);
	MOVLW .16
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	GOTO  printf
			;}
			;
			;//Reads a register from LIS
			;uns8 read_register(uns8 register_name)
			;{
read_register
	MOVWF register_name
			;    uns8 in_byte;
			;    
			;    i2c_ack_polling(DEVICE_WRITE);
	MOVLW .232
	CALL  i2c_ack_polling
			;
			;    i2c_start();
	CALL  i2c_start
			;    i2c_send_byte(DEVICE_WRITE); 
	MOVLW .232
	CALL  i2c_send_byte
			;    i2c_send_byte(register_name); //Write register address   
	MOVF  register_name,W
	CALL  i2c_send_byte
			;    //i2c_stop();
			;
			;    i2c_start(); //Repeat start (SR)
	CALL  i2c_start
			;    i2c_send_byte(DEVICE_READ); //Now ask the IC to report on the last command
	MOVLW .233
	CALL  i2c_send_byte
			;    in_byte = i2c_read_byte();
	CALL  i2c_read_byte
	MOVWF in_byte
			;    i2c_stop();
	CALL  i2c_stop
			;        
			;    return(in_byte);
	MOVF  in_byte,W
	RETURN
			;}
			;
			;//Write to a register in LIS
			;void write_register(uns8 register_name, uns8 register_value)
			;{
write_register
	MOVWF register_value
			;    i2c_ack_polling(DEVICE_WRITE);
	MOVLW .232
	CALL  i2c_ack_polling
			;
			;    i2c_start();
	CALL  i2c_start
			;    i2c_send_byte(DEVICE_WRITE); 
	MOVLW .232
	CALL  i2c_send_byte
			;    i2c_send_byte(register_name); //Write register address
	MOVF  register_name_2,W
	CALL  i2c_send_byte
			;    i2c_send_byte(register_value); //Write data
	MOVF  register_value,W
	CALL  i2c_send_byte
			;    i2c_stop();
	GOTO  i2c_stop
			;
			;    //Return nothing
			;}
			;
			;//Software I2C Routines
			;//====================================
			;void i2c_ack_polling(uns8 device_address)
			;{
i2c_ack_polling
	MOVWF device_address
			;    while(1)
			;    {
			;        i2c_start();
m051	CALL  i2c_start
			;        if (i2c_send_byte(device_address) == ACK) break;
	MOVF  device_address,W
	CALL  i2c_send_byte
	BTFSS 0x03,Carry
	GOTO  m051
	GOTO  i2c_stop
			;    }
			;    i2c_stop();
			;}
			;
			;void i2c_start(void)
			;{
i2c_start
			;    WRITE_sda();
	BSF   0x03,RP0
	BCF   TRISB,6
			;    SDA = 1;
	BCF   0x03,RP0
	BSF   PORTB,6
			;    delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;
			;    SCL = 1;
	BSF   PORTB,7
			;    delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;
			;    SDA = 0;
	BCF   PORTB,6
			;    delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	GOTO  delay_us
			;}
			;
			;//The I2C Clock has a minimum of 2us high time and 2us low time
			;void i2c_stop(void)
			;{
i2c_stop
			;    SCL = 0;
	BCF   PORTB,7
			;    delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;
			;    WRITE_sda();
	BSF   0x03,RP0
	BCF   TRISB,6
			;
			;    SDA = 0;
	BCF   0x03,RP0
	BCF   PORTB,6
			;    delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;
			;    SCL = 1;
	BSF   PORTB,7
			;    delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;
			;    SDA = 1;
	BSF   PORTB,6
			;    delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	GOTO  delay_us
			;}
			;
			;//The I2C Clock has a minimum of 2us high time and 2us low time
			;//8MHz = 0.5us per instruction
			;uns8 i2c_read_byte(void)
			;{
i2c_read_byte
			;    int j, in_byte;
			;
			;    SCL = 0;
	BCF   PORTB,7
			;
			;    READ_sda();
	BSF   0x03,RP0
	BSF   TRISB,6
			;
			;    for(j = 0 ; j < 8 ; j++)
	BCF   0x03,RP0
	CLRF  j
m052	BTFSC j,7
	GOTO  m053
	MOVLW .8
	SUBWF j,W
	BTFSC 0x03,Carry
	GOTO  m054
			;    {
			;        SCL = 0;
m053	BCF   PORTB,7
			;        delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;
			;        SCL = 1;
	BSF   PORTB,7
			;        delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;
			;        in_byte = rl(in_byte);
	RLF   in_byte_2,1
			;        in_byte.0 = SDA;
	BCF   in_byte_2,0
	BTFSC PORTB,6
	BSF   in_byte_2,0
			;    }
	INCF  j,1
	GOTO  m052
			;
			;    //Send 9th bit acknowledge
			;/*
			;    For single byte reads, there is NMAK or no master acknowledge
			;    SCL = 0;
			;    WRITE_sda();
			;    SDA = 0;
			;    delay_us(I2C_DELAY);
			;    SCL = 1;
			;
			;    delay_us(I2C_DELAY);
			;    SCL = 0;
			;
			;    delay_us(I2C_DELAY);
			;    SDA = 1;
			;    while(1);
			;*/
			;    return(in_byte);
m054	MOVF  in_byte_2,W
	RETURN
			;}
			;
			;//The I2C Clock has a minimum of 2us high time and 2us low time
			;//8MHz = 500ns per instruction
			;bit i2c_send_byte(uns8 out_byte)
			;{
i2c_send_byte
	MOVWF out_byte
			;    uns8 i;
			;
			;    WRITE_sda();
	BSF   0x03,RP0
	BCF   TRISB,6
			;
			;    for(i = 0 ; i < 8 ; i++)
	BCF   0x03,RP0
	CLRF  i_3
m055	MOVLW .8
	SUBWF i_3,W
	BTFSC 0x03,Carry
	GOTO  m056
			;    {
			;        SCL = 0;
	BCF   PORTB,7
			;        delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;
			;        out_byte = rl(out_byte);
	RLF   out_byte,1
			;        SDA = Carry;
	BTFSS 0x03,Carry
	BCF   PORTB,6
	BTFSC 0x03,Carry
	BSF   PORTB,6
			;        delay_us(5);
	MOVLW .5
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;
			;        SCL = 1;
	BSF   PORTB,7
			;        delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;    }
	INCF  i_3,1
	GOTO  m055
			;
			;    //Read ack
			;    SCL = 0;
m056	BCF   PORTB,7
			;    delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;
			;    READ_sda();
	BSF   0x03,RP0
	BSF   TRISB,6
			;
			;    SCL = 1;
	BCF   0x03,RP0
	BSF   PORTB,7
			;    delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;
			;    //Wait for IC to acknowledge
			;    for(i = 0 ; i < 255 ; i++)
	CLRF  i_3
m057	INCF  i_3,W
	BTFSC 0x03,Zero_
	GOTO  m058
			;        if(SDA == 0) break;
	BTFSS PORTB,6
	GOTO  m058
			;
			;    SCL = 0;
	INCF  i_3,1
	GOTO  m057
m058	BCF   PORTB,7
			;    delay_us(I2C_DELAY);
	MOVLW .1
	MOVWF x
	CLRF  x+1
	CALL  delay_us
			;
			;    if (i == 255) return(NO_ACK);
	INCFSZ i_3,W
	GOTO  m059
	BCF   0x03,Carry
	RETURN
			;    
			;    return(ACK);
m059	BSF   0x03,Carry
	RETURN

	END


; *** KEY INFO ***

; 0x0057 P0    9 word(s)  0 % : delay_us
; 0x0060 P0   24 word(s)  1 % : delay_ms
; 0x0078 P0   26 word(s)  1 % : delay_s_lp
; 0x0092 P0   16 word(s)  0 % : enable_uart_TX
; 0x00A2 P0   19 word(s)  0 % : enable_uart_RX
; 0x00B5 P0    6 word(s)  0 % : putc
; 0x00BB P0    6 word(s)  0 % : getc
; 0x00C1 P0   21 word(s)  1 % : scanc
; 0x00D6 P0   20 word(s)  0 % : bin2Hex
; 0x00EA P0  215 word(s) 10 % : printf
; 0x0004 P0   57 word(s)  2 % : _const1
; 0x01CC P0   19 word(s)  0 % : boot_up
; 0x020F P0   75 word(s)  3 % : adjd_s371_read
; 0x01DF P0   48 word(s)  2 % : adjd_init
; 0x0275 P0    7 word(s)  0 % : i2c_ack_polling
; 0x027C P0   18 word(s)  0 % : i2c_start
; 0x028E P0   23 word(s)  1 % : i2c_stop
; 0x02A5 P0   29 word(s)  1 % : i2c_read_byte
; 0x02C2 P0   62 word(s)  3 % : i2c_send_byte
; 0x025A P0   16 word(s)  0 % : read_register
; 0x026A P0   11 word(s)  0 % : write_register
; 0x01C1 P0   11 word(s)  0 % : main

; RAM usage: 32 bytes (32 local), 336 bytes free
; Maximum call level: 5
;  Codepage 0 has  765 word(s) :  37 %
;  Codepage 1 has    0 word(s) :   0 %
; Total of 739 code words (18 %)
